//+------------------------------------------------------------------+
//|                                                     forex.ovo.cz |
//| $Id: KeepSessionAlive.mq4 5 2012-05-15 05:56:31Z ovo $
//+------------------------------------------------------------------+

/**
* Script places a single order far away from market and updates it regularily.
* 
*/

#include <stderror.mqh>
#include <stdlib.mqh>

// seconds to sleep
#define SLEEP_TIME 29
#define MagicNumber 64662848

int orderNumber;

/** never triggers start */
int start() {
}

/** loops in init until removed */
int init() {

   // loop until removed   
   while (! IsStopped()) {
      bool isOrderPresent = OrderSelect(orderNumber,SELECT_BY_TICKET);
      if((! isOrderPresent) || (OrderCloseTime() > 0)) {
         isOrderPresent = findOrder();
      }
      int startTime = GetTickCount();
      
      if(! isOrderPresent) {
      
         // Creates new order for chat symbol
         OrderSend(Symbol(),OP_BUYLIMIT,MarketInfo(Symbol(), MODE_MINLOT),MarketInfo(Symbol(), MODE_TICKSIZE),0,0,0,0,MagicNumber,0);
      } else {         
         
         // Changes selected order
         string orderSymbol = OrderSymbol();
         double tickSize = MarketInfo(orderSymbol, MODE_TICKSIZE);
         double orderPrice = OrderOpenPrice();
         if (orderPrice==tickSize) {
            orderPrice = NormalizeDouble(2 * tickSize, MarketInfo(orderSymbol, MODE_DIGITS));
         } else {
            orderPrice = tickSize;
         }
         OrderModify(OrderTicket(), orderPrice,0,0,0);         
      }
      int delay = GetTickCount()-startTime;
      int error = GetLastError();
      string line1 = "";
      if (error == ERR_NO_ERROR) {
         line1 = "Execution Time: " + delay;
      } else {
         line1 = ErrorDescription(error);
      }

      datetime timeToUpdate = TimeLocal() + SLEEP_TIME;
      
      // waits for the next run
      while ((TimeLocal() < timeToUpdate) && ! IsStopped()) {
         Comment(line1, "\n", "Update in ", (timeToUpdate - TimeLocal()), " seconds." );
         Sleep(50);
         if (IsTradeContextBusy()) {
             timeToUpdate = TimeLocal() + SLEEP_TIME;
             line1 = "Countdown reset by anoter script.";
         }
      }
   }
   return(0);
}
  
int deinit() {
   Comment("");
}

bool findOrder() {
   bool found = false;
   for(int i=0; i<OrdersTotal(); i++) {
      OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
      if(OrderMagicNumber()==MagicNumber) {
         orderNumber = OrderTicket();
         found = true;
         break;
      }         
   }   
   return(found);
}